package com.yidianling.ydlcommon.custom.router

import android.app.Activity
import android.app.Application
import android.support.annotation.StringRes
import android.support.v7.app.AppCompatActivity
import com.yidianling.ydlcommon.core.base.BaseApplication
import com.yidianling.ydlcommon.custom.GlobalInfo
import com.yidianling.ydlcommon.custom.data.PlatformDataManager
import com.yidianling.ydlcommon.custom.actions.imagepicker.PickerCallback
import com.yidianling.ydlcommon.custom.actions.imagepicker.YdlImagePicker
import com.yidianling.ydlcommon.custom.pay.PayActivity
import com.yidianling.ydlcommon.custom.pay.PayParams
import com.yidianling.ydlcommon.custom.utils.remind.ToastHelper

/**
 * author : Zhangwenchao
 * e-mail : zhangwch@yidianling.com
 * time   : 2018/04/24
 *
 *  项目通用模块对外提供的方法
 */
class YdlCommonOut {

    companion object {

        fun showToast(content: String) {
            ToastHelper.show(content)
        }

        fun showToast(@StringRes stringId: Int) {
            ToastHelper.show(stringId)
        }

        fun getApp(): Application {
            return BaseApplication.getApp()
        }

        // 打开支付页面
        fun startPayActivity(activity: Activity, payParams: PayParams, requestCode: Int) {
            activity.startActivityForResult(PayActivity.newIntent(activity, payParams), requestCode)
        }

        // 是否开启了声音
        fun isVoice(): Boolean = PlatformDataManager.getLocal().isVoice()

        fun putVoice(voice: Boolean) {
            PlatformDataManager.getLocal().putVoice(voice)
        }

        // 是否开启了震动
        fun isShake(): Boolean = PlatformDataManager.getLocal().isShake()

        fun putShake(shake: Boolean) {
            PlatformDataManager.getLocal().putShake(shake)
        }

        fun getGlobalInfo(): GlobalInfo? {
            return PlatformDataManager.getRam().getGlobalInfo()
        }

        fun setGlobalInfo(globalInfo: GlobalInfo) {
            PlatformDataManager.getRam().setGlobalInfo(globalInfo)
        }

        fun putNewYearKeyword(key: String, value: GlobalInfo.GlobalData.NewYearKeyword?) {
            PlatformDataManager.getRam().putNewYearKeyword(key, value)
        }

        fun getNewYearKeyword(key: String): GlobalInfo.GlobalData.NewYearKeyword? {
            return PlatformDataManager.getRam().getNewYearKeyword(key)
        }

        fun getNewYearKeyWordByContent(content: String?): GlobalInfo.GlobalData.NewYearKeyword? {
            return PlatformDataManager.getRam().getGlobalInfo()?.info?.getNewYearKeyWordByContent(content)
        }

        fun startPicker(activity: AppCompatActivity, openCamera: Boolean, callback: PickerCallback) {
            YdlImagePicker.startPicker(activity, openCamera, callback)
        }

        fun getChannelName(): String {
            return PlatformDataManager.getRam().getChannelName()
        }
    }
}